﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Helpers;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Dynamic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Syncfusion.UI.Xaml.Grid.Helpers;
// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace SfDataGridDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.Loaded += MainPage_Loaded;
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            var list = new List<dynamic>();
            list.Add(CreateDynamicObj("David", 1001, "Asst.Manager", 118));
            list.Add(CreateDynamicObj("Alex", 1002, "Senior Developer", 123));
            list.Add(CreateDynamicObj("Christopher", 1003, "Senior Developer", 121));
            list.Add(CreateDynamicObj("Mary", 1004, "Accountant", 120));
            list.Add(CreateDynamicObj("Angeline", 1005, "Asst.Manager", 105));
            list.Add(CreateDynamicObj("Andrew", 1006, "Manager", 103));
            list.Add(CreateDynamicObj("Michael", 1007, "Senior Developer", 124));
            SfGrid.ItemsSource = list;
        }
        //Listening to the DetailsViewExpanding Event.
        //Making it Async with the Async and Await keyword to execute asynchronously.

        //On accessing the DetailsViewSource property of GridDetailsViewExpandingEventArgs we can reset the ItemsSource of DetailsViewGrid

        private void SfGrid_DetailsViewExpanding(object sender,
            Syncfusion.UI.Xaml.Grid.GridDetailsViewExpandingEventArgs e)
        {
            e.DetailsViewItemsSource.Clear();
            var list = new ObservableCollection<dynamic>();
            e.DetailsViewItemsSource.Add("Persons", list);
            var underlyingList = GetItems(list);
        }

        //We have Populated the data for the DetailsView Grid in this method asynchronously by holding the DetailsView ExpandingEvent
        //till the data gets created or Loaded from an external source.
        private async Task<ObservableCollection<dynamic>> GetItems(ObservableCollection<dynamic> dynamicList)
        {
            await Task.Delay(2000);
            dynamicList.Add(CreateDynamicObj("David", 1001, "Asst.Manager", 118));
            dynamicList.Add(CreateDynamicObj("Alex", 1002, "Senior Developer", 123));
            dynamicList.Add(CreateDynamicObj("Christopher", 1003, "Senior Developer", 121));
            dynamicList.Add(CreateDynamicObj("Mary", 1004, "Accountant", 120));
            dynamicList.Add(CreateDynamicObj("Angeline", 1005, "Asst.Manager", 105));
            dynamicList.Add(CreateDynamicObj("Andrew", 1006, "Manager", 103));
            dynamicList.Add(CreateDynamicObj("Michael", 1007, "Senior Developer", 124));

            return dynamicList;
        }
        
        private dynamic CreateDynamicObj(string name, int employeeid, string Details, int contactnumber)
        {
            ExpandoObject exp = new ExpandoObject();
            ((IDictionary<string, object>)exp).Add("Name", name);
            ((IDictionary<string, object>)exp).Add("EmployeeID", employeeid);
            ((IDictionary<string, object>)exp).Add("Details", Details);
            ((IDictionary<string, object>)exp).Add("ContactNumber", contactnumber);
            return exp;
        }
        
    }
}

 